<?php
/**
 * ReplacePropertyRequest
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\PimClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi PIM.
 *
 * PIM
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\PimClient\Dto;

use \ArrayAccess;
use \Ensi\PimClient\ObjectSerializer;

/**
 * ReplacePropertyRequest Class Doc Comment
 *
 * @category Class
 * @package  Ensi\PimClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class ReplacePropertyRequest implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'ReplacePropertyRequest';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'name' => 'string',
        'display_name' => 'string',
        'code' => 'string',
        'type' => 'string',
        'hint_value' => 'string',
        'hint_value_name' => 'string',
        'is_multiple' => 'bool',
        'is_filterable' => 'bool',
        'is_public' => 'bool',
        'is_active' => 'bool',
        'is_required' => 'bool',
        'has_directory' => 'bool',
        'is_moderated' => 'bool'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'name' => null,
        'display_name' => null,
        'code' => null,
        'type' => null,
        'hint_value' => null,
        'hint_value_name' => null,
        'is_multiple' => null,
        'is_filterable' => null,
        'is_public' => null,
        'is_active' => null,
        'is_required' => null,
        'has_directory' => null,
        'is_moderated' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'name' => false,
        'display_name' => false,
        'code' => false,
        'type' => false,
        'hint_value' => false,
        'hint_value_name' => false,
        'is_multiple' => false,
        'is_filterable' => false,
        'is_public' => false,
        'is_active' => false,
        'is_required' => false,
        'has_directory' => false,
        'is_moderated' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::$openAPINullables[$property])) {
            return self::$openAPINullables[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'name' => 'name',
        'display_name' => 'display_name',
        'code' => 'code',
        'type' => 'type',
        'hint_value' => 'hint_value',
        'hint_value_name' => 'hint_value_name',
        'is_multiple' => 'is_multiple',
        'is_filterable' => 'is_filterable',
        'is_public' => 'is_public',
        'is_active' => 'is_active',
        'is_required' => 'is_required',
        'has_directory' => 'has_directory',
        'is_moderated' => 'is_moderated'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'name' => 'setName',
        'display_name' => 'setDisplayName',
        'code' => 'setCode',
        'type' => 'setType',
        'hint_value' => 'setHintValue',
        'hint_value_name' => 'setHintValueName',
        'is_multiple' => 'setIsMultiple',
        'is_filterable' => 'setIsFilterable',
        'is_public' => 'setIsPublic',
        'is_active' => 'setIsActive',
        'is_required' => 'setIsRequired',
        'has_directory' => 'setHasDirectory',
        'is_moderated' => 'setIsModerated'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'name' => 'getName',
        'display_name' => 'getDisplayName',
        'code' => 'getCode',
        'type' => 'getType',
        'hint_value' => 'getHintValue',
        'hint_value_name' => 'getHintValueName',
        'is_multiple' => 'getIsMultiple',
        'is_filterable' => 'getIsFilterable',
        'is_public' => 'getIsPublic',
        'is_active' => 'getIsActive',
        'is_required' => 'getIsRequired',
        'has_directory' => 'getHasDirectory',
        'is_moderated' => 'getIsModerated'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('name', $data, null);
        $this->setIfExists('display_name', $data, null);
        $this->setIfExists('code', $data, null);
        $this->setIfExists('type', $data, null);
        $this->setIfExists('hint_value', $data, null);
        $this->setIfExists('hint_value_name', $data, null);
        $this->setIfExists('is_multiple', $data, null);
        $this->setIfExists('is_filterable', $data, null);
        $this->setIfExists('is_public', $data, null);
        $this->setIfExists('is_active', $data, null);
        $this->setIfExists('is_required', $data, null);
        $this->setIfExists('has_directory', $data, null);
        $this->setIfExists('is_moderated', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets name
     *
     * @return string|null
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string|null $name Название свойства
     *
     * @return $this
     */
    public function setName($name)
    {


        /*if (is_null($name)) {
            throw new \InvalidArgumentException('non-nullable name cannot be null');
        }*/
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets display_name
     *
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->container['display_name'];
    }

    /**
     * Sets display_name
     *
     * @param string|null $display_name Публичное наименование
     *
     * @return $this
     */
    public function setDisplayName($display_name)
    {


        /*if (is_null($display_name)) {
            throw new \InvalidArgumentException('non-nullable display_name cannot be null');
        }*/
        $this->container['display_name'] = $display_name;

        return $this;
    }

    /**
     * Gets code
     *
     * @return string|null
     */
    public function getCode()
    {
        return $this->container['code'];
    }

    /**
     * Sets code
     *
     * @param string|null $code Код свойства
     *
     * @return $this
     */
    public function setCode($code)
    {


        /*if (is_null($code)) {
            throw new \InvalidArgumentException('non-nullable code cannot be null');
        }*/
        $this->container['code'] = $code;

        return $this;
    }

    /**
     * Gets type
     *
     * @return string|null
     */
    public function getType()
    {
        return $this->container['type'];
    }

    /**
     * Sets type
     *
     * @param string|null $type Тип свойства из PropertyTypeEnum
     *
     * @return $this
     */
    public function setType($type)
    {


        /*if (is_null($type)) {
            throw new \InvalidArgumentException('non-nullable type cannot be null');
        }*/
        $this->container['type'] = $type;

        return $this;
    }

    /**
     * Gets hint_value
     *
     * @return string|null
     */
    public function getHintValue()
    {
        return $this->container['hint_value'];
    }

    /**
     * Sets hint_value
     *
     * @param string|null $hint_value Подсказка при заполнении для значения
     *
     * @return $this
     */
    public function setHintValue($hint_value)
    {


        /*if (is_null($hint_value)) {
            throw new \InvalidArgumentException('non-nullable hint_value cannot be null');
        }*/
        $this->container['hint_value'] = $hint_value;

        return $this;
    }

    /**
     * Gets hint_value_name
     *
     * @return string|null
     */
    public function getHintValueName()
    {
        return $this->container['hint_value_name'];
    }

    /**
     * Sets hint_value_name
     *
     * @param string|null $hint_value_name Подсказка при заполнении для названия значения
     *
     * @return $this
     */
    public function setHintValueName($hint_value_name)
    {


        /*if (is_null($hint_value_name)) {
            throw new \InvalidArgumentException('non-nullable hint_value_name cannot be null');
        }*/
        $this->container['hint_value_name'] = $hint_value_name;

        return $this;
    }

    /**
     * Gets is_multiple
     *
     * @return bool|null
     */
    public function getIsMultiple()
    {
        return $this->container['is_multiple'];
    }

    /**
     * Sets is_multiple
     *
     * @param bool|null $is_multiple Поддерживает множественные значения
     *
     * @return $this
     */
    public function setIsMultiple($is_multiple)
    {


        /*if (is_null($is_multiple)) {
            throw new \InvalidArgumentException('non-nullable is_multiple cannot be null');
        }*/
        $this->container['is_multiple'] = $is_multiple;

        return $this;
    }

    /**
     * Gets is_filterable
     *
     * @return bool|null
     */
    public function getIsFilterable()
    {
        return $this->container['is_filterable'];
    }

    /**
     * Sets is_filterable
     *
     * @param bool|null $is_filterable Выводится в фильтрах на витрине
     *
     * @return $this
     */
    public function setIsFilterable($is_filterable)
    {


        /*if (is_null($is_filterable)) {
            throw new \InvalidArgumentException('non-nullable is_filterable cannot be null');
        }*/
        $this->container['is_filterable'] = $is_filterable;

        return $this;
    }

    /**
     * Gets is_public
     *
     * @return bool|null
     */
    public function getIsPublic()
    {
        return $this->container['is_public'];
    }

    /**
     * Sets is_public
     *
     * @param bool|null $is_public Выводить на витрине
     *
     * @return $this
     */
    public function setIsPublic($is_public)
    {


        /*if (is_null($is_public)) {
            throw new \InvalidArgumentException('non-nullable is_public cannot be null');
        }*/
        $this->container['is_public'] = $is_public;

        return $this;
    }

    /**
     * Gets is_active
     *
     * @return bool|null
     */
    public function getIsActive()
    {
        return $this->container['is_active'];
    }

    /**
     * Sets is_active
     *
     * @param bool|null $is_active Активность атрибута
     *
     * @return $this
     */
    public function setIsActive($is_active)
    {


        /*if (is_null($is_active)) {
            throw new \InvalidArgumentException('non-nullable is_active cannot be null');
        }*/
        $this->container['is_active'] = $is_active;

        return $this;
    }

    /**
     * Gets is_required
     *
     * @return bool|null
     */
    public function getIsRequired()
    {
        return $this->container['is_required'];
    }

    /**
     * Sets is_required
     *
     * @param bool|null $is_required Обязательность заполнения для общего (is_common=true) атрибута
     *
     * @return $this
     */
    public function setIsRequired($is_required)
    {


        /*if (is_null($is_required)) {
            throw new \InvalidArgumentException('non-nullable is_required cannot be null');
        }*/
        $this->container['is_required'] = $is_required;

        return $this;
    }

    /**
     * Gets has_directory
     *
     * @return bool|null
     */
    public function getHasDirectory()
    {
        return $this->container['has_directory'];
    }

    /**
     * Sets has_directory
     *
     * @param bool|null $has_directory Атрибут имеет справочник значений
     *
     * @return $this
     */
    public function setHasDirectory($has_directory)
    {


        /*if (is_null($has_directory)) {
            throw new \InvalidArgumentException('non-nullable has_directory cannot be null');
        }*/
        $this->container['has_directory'] = $has_directory;

        return $this;
    }

    /**
     * Gets is_moderated
     *
     * @return bool|null
     */
    public function getIsModerated()
    {
        return $this->container['is_moderated'];
    }

    /**
     * Sets is_moderated
     *
     * @param bool|null $is_moderated Атрибут модерируется
     *
     * @return $this
     */
    public function setIsModerated($is_moderated)
    {


        /*if (is_null($is_moderated)) {
            throw new \InvalidArgumentException('non-nullable is_moderated cannot be null');
        }*/
        $this->container['is_moderated'] = $is_moderated;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


